//     TDVDrivesCombo & TDVDrivesList 1.1
//          (c) Jakub Dusek (1999)
//
//  Tested in Delphi 2 and 4, but I think that allready
//       works in other 32 bit Delphi versions
//         (mail me some possible problems)
//
// This source code is not public domain and can
//     be distributed only with this header
//           and included readme file
//
//     For updates and more components visit
//          http://drivi.misto.cz/delphi
//
//      Mail me some bugs and good ideas to
//                 drivi@seznam.cz

{$IFNDEF VER80}
 {$IFNDEF VER90}
  {$IFNDEF VER93}
    {$IFNDEF VER100}
      {$IFNDEF VER110}
        {$DEFINE DV4}
      {$ENDIF}
    {$ENDIF}
  {$ENDIF}
 {$ENDIF}
{$ENDIF}

unit DVDrives;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,ShellApi{$IFDEF DV4},imglist{$ENDIF};

type

//Standart types

TDriveType = (dtUnknown, dtNonExisting, dtRemovable,
              dtFixed, dtRemote, dtCDROM, dtRamDisk);

TViewDrivesType = set of TDriveType;

TIconSize = (isSmall, isLarge);

TTextCase = (tcLowerCase, tcUpperCase);

//TDVDrivesCombo

TDVDrivesCombo = class(TCustomComboBox)
  private
    FAutoUpdate:Boolean;
    FDisplayBrackets:Boolean;
    FDisplayIcons:Boolean;
    FDisplayLabel:Boolean;
    FDisplaySysName:Boolean;
    FDrive:char;
    FIconsSize:TIconSize;
    FTextCase:TTextCase;
    FViewDrivesType:TViewDrivesType;
    procedure SetDisplayBrackets(Value:Boolean);
    procedure SetDisplayIcons(Value:Boolean);
    procedure SetDisplayLabel(Value:Boolean);
    procedure SetDisplaySysName(Value:Boolean);
    procedure SetDrive(Value:char);
    procedure SetCase(Value:TTextCase);
    procedure SetIconsSize(Value:TIconSize);
    procedure SetViewDrivesType(Value:TViewDrivesType);
    procedure CMFontChanged(var Message: TMessage);message CM_FONTCHANGED;
  protected
    procedure DropDown;override;
    procedure DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState);override;
    procedure Change;override;
  public
    constructor Create(AOwner:TComponent);override;
    procedure CreateWnd; override;
    procedure Loaded; override;
  published
    property AutoUpdate:Boolean read FAutoUpdate write FAutoUpdate default true;
    property DisplayBrackets:Boolean read FDisplayBrackets write SetDisplayBrackets default True;
    property DisplayIcons:Boolean read FDisplayIcons write SetDisplayIcons default True;
    property DisplayLabel:Boolean read FDisplayLabel write SetDisplaylabel default True;
    property DisplaySysName:Boolean read FDisplaySysName write SetDisplaySysName default True;
    property Drive:Char read FDrive write SetDrive;
    property IconsSize:TIconSize read FIconsSize write SetIconsSize;
    property TextCase:TTextCase read FTextCase write SetCase default tcLowerCase;
    property ViewDrivesType:TViewDrivesType read FViewDrivesType write SetViewDrivesType default [dtRemovable,dtFixed, dtRemote, dtCDROM, dtRamDisk];
    {$IFDEF DV4}
    property Anchors;
    property BiDiMode;
    property Constraints;
    property DragKind;
    property ParentBiDiMode;
    property OnEndDock;
    property OnStartDock;
    {$ENDIF}
    {$IFNDEF VER90}
    property ImeMode;
    property ImeName;
    {$ENDIF}
    property Color;
    property Ctl3D;
    property DragCursor;
    property DragMode;
    property DropDownCount;
    property Enabled;
    property Font;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property Visible;
    property OnChange;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnDropDown;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnStartDrag;
    procedure UpdateDrives;
  end;

//TDVDrivesList

TDVDrivesList = class(TCustomListBox)
  private
    FDisplayBrackets:Boolean;
    FDisplayIcons:Boolean;
    FDisplayLabel:Boolean;
    FDisplaySysName:Boolean;
    FDrive:char;
    FIconsSize:TIconSize;
    FTextCase:TTextCase;
    FViewDrivesType:TViewDrivesType;
    procedure SetDisplayBrackets(Value:Boolean);
    procedure SetDisplayIcons(Value:Boolean);
    procedure SetDisplayLabel(Value:Boolean);
    procedure SetDisplaySysName(Value:Boolean);
    procedure SetDrive(Value:char);
    procedure SetCase(Value:TTextCase);
    procedure SetIconsSize(Value:TIconSize);
    procedure SetViewDrivesType(Value:TViewDrivesType);
    procedure CMFontChanged(var Message: TMessage);message CM_FONTCHANGED;
  protected
    procedure DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState);override;
    procedure Click;override;
  public
    constructor Create(AOwner:TComponent);override;
    procedure CreateWnd;override;
    procedure Loaded;override;
  published
    property DisplayBrackets:Boolean read FDisplayBrackets write SetDisplayBrackets default True;
    property DisplayIcons:Boolean read FDisplayIcons write SetDisplayIcons default True;
    property DisplayLabel:Boolean read FDisplayLabel write SetDisplaylabel default True;
    property DisplaySysName:Boolean read FDisplaySysName write SetDisplaySysName default True;
    property Drive:Char read FDrive write SetDrive;
    property IconsSize:TIconSize read FIconsSize write SetIconsSize;
    property TextCase:TTextCase read FTextCase write SetCase default tcLowerCase;
    property ViewDrivesType:TViewDrivesType read FViewDrivesType write SetViewDrivesType default [dtRemovable,dtFixed, dtRemote, dtCDROM, dtRamDisk];
    property Align;
    {$IFDEF DV4}
    property Anchors;
    property BiDiMode;
    property Constraints;
    property DragKind;
    property ParentBiDiMode;
    property OnEndDock;
    property OnStartDock;
    {$ENDIF}
    {$IFNDEF VER90}
    property ImeMode;
    property ImeName;
    {$ENDIF}
    property BorderStyle;
    property Color;
    property Columns;
    property Ctl3D;
    property DragCursor;
    property DragMode;
    property Enabled;
    property ExtendedSelect;
    property Font;
    property IntegralHeight;
    property MultiSelect;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnStartDrag;
    procedure UpdateDrives;
  end;

procedure Register;

var SFI:TSHFileInfo;
    SysIL: uint;
    Larges,Smalls:TImageList;

implementation

procedure Register;
begin
  RegisterComponents('Drivi Lib', [TDVDrivesCombo]);
  RegisterComponents('Drivi Lib', [TDVDrivesList]);
end;

//Standart utilities

function GetItemHeight(Font: TFont): Integer;
var
  DC: HDC;
  Fnt: HFont;
  Metrics: TTextMetric;
begin
  DC := GetDC(0);
  try
    Fnt := SelectObject(DC, Font.Handle);
    GetTextMetrics(DC, Metrics);
    SelectObject(DC, Fnt);
  finally
    ReleaseDC(0, DC);
  end;
  Result := Metrics.tmHeight + 1;
end;

procedure DrawAssociatedImage(s:string;Cnvs:TCanvas;x,y:integer;Size:TIconSize);
var info:tshfileinfo;
begin
  fillchar(info,sizeof(tshfileinfo),0);
  shgetfileinfo(PChar(s),0,info,sizeof(tshfileinfo),shgfi_icon or shgfi_smallicon);
  case Size of
    isSmall: Smalls.Draw(Cnvs,x,y,info.iIcon);
    isLarge: Larges.Draw(Cnvs,x,y,info.iIcon);
  end;
end;

function GetDriveType (Drive : char) : TDriveType;
begin
  result := TDriveType (Windows.GetDriveType(PChar(Drive + ':\')));
end;

procedure GetLogicalDriveList (List : TStrings; DrivesType:TViewDrivesType);
 var
   Num  : integer;
   Bits : set of 0..25;
 begin
   List.Clear;
   integer (Bits) := Windows.GetLogicalDrives;
   for Num := 0 to 25 do
     if Num in Bits then
      if GetDriveType(Char (Num + Ord('A'))) in DrivesType then
      List.Add (Char (Num + Ord('A')))
end;

function GetVolumeLabel(Drive:char):string;
var VolLab:array [0..max_path] of char;
    MaxLength,SysFlag:DWord;
    OldErrorMode:integer;
begin
  OldErrorMode := SetErrorMode(SEM_FAILCRITICALERRORS);
  try
    if GetVolumeInformation(PChar(drive+':\'), VolLab, 255,
                       nil, MaxLength,
                       SysFlag, nil, 255) then Result:=vollab;
  finally
    SetErrorMode(OldErrorMode);
  end;
end;

//TDVDrivesCombo

constructor TDVDrivesCombo.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);
  Style:=csOwnerDrawFixed;
  FViewDrivesType:=[dtRemovable,dtFixed, dtRemote, dtCDROM, dtRamDisk];
  AutoUpdate:=True;
  DisplayIcons:=True;
  DisplayBrackets:=True;
  DisplayLabel:=True;
  DisplaySysName:=True;
end;

procedure TDVDrivesCombo.CreateWnd;
begin
  inherited CreateWnd;
  UpdateDrives;
end;

procedure TDVDrivesCombo.Loaded;
begin
  inherited Loaded;
  SetDrive(FDrive);
end;

procedure TDVDrivesCombo.DropDown;
begin
  if FAutoUpdate then UpdateDrives;
  inherited dropdown;
end;

procedure TDVDrivesCombo.SetIconsSize(Value:TIconSize);
begin
  FIconsSize:=Value;
  case Value of
    isSmall:
    begin
      if GetItemHeight(Font)<18 then itemheight:=18;
      Height:=itemheight;
    end;
    isLarge:
    begin
      if GetItemHeight(Font)<34 then itemheight:=34;
      Height:=itemheight;
    end;
  end;
  RecreateWnd;
  Invalidate;
end;

procedure TDVDrivesCombo.SetDisplayIcons(Value:Boolean);
begin
  FDisplayIcons:=Value;
  invalidate;
end;

procedure TDVDrivesCombo.UpdateDrives;
var s:string;
begin
  s:=Items[ItemIndex];
  Items.Clear;
  GetLogicalDriveList(Items,FViewDrivesType);
  if Items.Count<>0 then
  begin
    if Items.IndexOf(s)<>-1 then ItemIndex:=Items.IndexOf(s)
    else
      ItemIndex:=0;
    s:=Items[ItemIndex];
    FDrive:=s[1];
  end;
end;

procedure TDVDrivesCombo.Change;
var s:string;
begin
  s:=items[ItemIndex];
  FDrive:=s[1];
  inherited Change;
end;

procedure TDVDrivesCombo.SetCase(Value:TTextCase);
begin
  FTextCase:=Value;
  Invalidate;
end;

procedure TDVDrivesCombo.SetViewDrivesType(Value:TViewDrivesType);
begin
  FViewDrivesType:=Value;
  UpdateDrives;
end;

procedure TDVDrivesCombo.SetDrive(Value:char);
begin
  if Items.indexof(Value)<>-1 then
  begin
    ItemIndex:=Items.IndexOf(Value);
    FDrive:=Value;
    if Assigned(OnChange) then OnChange(Self);
  end;
end;

procedure TDVDrivesCombo.SetDisplayBrackets(Value:Boolean);
begin
  FDisplayBrackets:=Value;
  Invalidate;
end;

procedure TDVDrivesCombo.SetDisplayLabel(Value:Boolean);
begin
  FDisplayLabel:=Value;
  Invalidate;
end;

procedure TDVDrivesCombo.SetDisplaySysName(Value:Boolean);
begin
  FDisplaySysName:=Value;
  Invalidate;
end;

procedure TDVDrivesCombo.CMFontChanged(var Message: TMessage);
begin
  inherited;
  ItemHeight:=GetItemHeight(Font);
  SetIconsSize(FIconsSize);
end;

procedure TDVDrivesCombo.DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState);
var az,sr:string;
    x,y:integer;
    info:tshfileinfo;
begin
  az:=Items[Index]+': ';
  sr:=Items[Index]+':\';
  if not FDisplaySysName then
  begin
    if (FDisplayLabel) and (getdrivetype(az[1])<>dtRemovable) then
    begin
      if FDisplayBrackets then az:=az+'[';
      az:=az+GetVolumeLabel(az[1]);
      if FDisplayBrackets then az:=az+']';
    end;
    case FTextCase of
      tcLowerCase: az:=LowerCase(az);
      tcUpperCase: az:=UpperCase(az);
    end;
  end
  else
  begin
    fillchar(info,sizeof(tshfileinfo),0);
    shgetfileinfo(PChar(sr),0,info,sizeof(tshfileinfo),shgfi_displayname);
    az:=info.szDisplayName;
  end;
  Canvas.fillrect(rect);
  rect.top:=rect.Top+1;
  rect.bottom:=rect.Bottom-1;
  rect.Left:=rect.Left+2;
  if FDisplayIcons then
  begin
    case FIconsSize of
      isSmall:
      begin
        y:=rect.Top+(((rect.Bottom-rect.Top)-16) div 2);
        x:=20;
      end;
      isLarge:
      begin
        y:=rect.Top+(((rect.Bottom-rect.Top)-32) div 2);
        x:=36;
      end;
    end;
    DrawAssociatedImage(sr,Canvas,rect.Left,y,FIconsSize);
  end
  else
    x:=2;
  rect.Left:=rect.Left+x;
  DrawText(Canvas.Handle, PChar(az), Length(az), Rect,
           DT_SINGLELINE or DT_VCENTER or DT_NOPREFIX);
end;

//TDVDrivesList

constructor TDVDrivesList.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);
  Style:=lbOwnerDrawFixed;
  FViewDrivesType:=[dtRemovable,dtFixed, dtRemote, dtCDROM, dtRamDisk];
  DisplayIcons:=True;
  DisplayBrackets:=True;
  DisplayLabel:=True;
  DisplaySysName:=True;
end;

procedure TDVDrivesList.CreateWnd;
begin
  inherited CreateWnd;
  UpdateDrives;
end;

procedure TDVDrivesList.Loaded;
begin
  inherited Loaded;
  SetDrive(FDrive);
end;

procedure TDVDrivesList.SetIconsSize(Value:TIconSize);
begin
  FIconsSize:=Value;
  case Value of
    isSmall: if GetItemHeight(Font)<18 then itemheight:=18;
    isLarge: if GetItemHeight(Font)<34 then itemheight:=34;
  end;
  RecreateWnd;
  Invalidate;
end;

procedure TDVDrivesList.SetDisplayIcons(Value:Boolean);
begin
  FDisplayIcons:=Value;
  invalidate;
end;

procedure TDVDrivesList.UpdateDrives;
var s:string;
begin
  if Items.Count<>0 then s:=Items[ItemIndex];
  Items.Clear;
  GetLogicalDriveList(Items,FViewDrivesType);
  if Items.Count<>0 then
  begin
    if Items.IndexOf(s)<>-1 then ItemIndex:=Items.IndexOf(s)
    else
      ItemIndex:=0;
    s:=Items[ItemIndex];
    FDrive:=s[1];
  end;
end;

procedure TDVDrivesList.Click;
var s:string;
begin
  s:=items[ItemIndex];
  FDrive:=s[1];
  inherited Click;
end;

procedure TDVDrivesList.SetCase(Value:TTextCase);
begin
  FTextCase:=Value;
  Invalidate;
end;

procedure TDVDrivesList.SetViewDrivesType(Value:TViewDrivesType);
begin
  FViewDrivesType:=Value;
  UpdateDrives;
end;

procedure TDVDrivesList.SetDrive(Value:char);
begin
  if Items.indexof(Value)<>-1 then
  begin
    ItemIndex:=Items.IndexOf(Value);
    FDrive:=Value;
    if Assigned(OnClick) then OnClick(Self);
  end;
end;

procedure TDVDrivesList.SetDisplayBrackets(Value:Boolean);
begin
  FDisplayBrackets:=Value;
  Invalidate;
end;

procedure TDVDrivesList.SetDisplayLabel(Value:Boolean);
begin
  FDisplayLabel:=Value;
  Invalidate;
end;

procedure TDVDrivesList.SetDisplaySysName(Value:Boolean);
begin
  FDisplaySysName:=Value;
  Invalidate;
end;

procedure TDVDrivesList.CMFontChanged(var Message: TMessage);
begin
  inherited;
  itemheight:=GetItemHeight(Font);
  SetIconsSize(FIconsSize);
end;

procedure TDVDrivesList.DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState);
var az,sr:string;
    x,y:integer;
    info:tshfileinfo;
begin
  az:=Items[Index]+': ';
  sr:=Items[Index]+':\';
  if not FDisplaySysName then
  begin
    if (FDisplayLabel) and (getdrivetype(az[1])<>dtRemovable) then
    begin
      if FDisplayBrackets then az:=az+'[';
      az:=az+GetVolumeLabel(az[1]);
      if FDisplayBrackets then az:=az+']';
    end;
    case FTextCase of
      tcLowerCase: az:=LowerCase(az);
      tcUpperCase: az:=UpperCase(az);
    end;
  end
  else
  begin
    fillchar(info,sizeof(tshfileinfo),0);
    shgetfileinfo(PChar(sr),0,info,sizeof(tshfileinfo),shgfi_displayname);
    az:=info.szDisplayName;
  end;
  Canvas.fillrect(rect);
  rect.top:=rect.Top+1;
  rect.bottom:=rect.Bottom-1;
  rect.Left:=rect.Left+2;
  if FDisplayIcons then
  begin
    case FIconsSize of
      isSmall:
      begin
        y:=rect.Top+(((rect.Bottom-rect.Top)-16) div 2);
        x:=20;
      end;
      isLarge:
      begin
        y:=rect.Top+(((rect.Bottom-rect.Top)-32) div 2);
        x:=36;
      end;
    end;
    DrawAssociatedImage(sr,Canvas,rect.Left,y,FIconsSize);
  end
  else
    x:=2;
  rect.Left:=rect.Left+x;
  DrawText(Canvas.Handle, PChar(az), Length(az), Rect,
           DT_SINGLELINE or DT_VCENTER or DT_NOPREFIX);
end;

initialization
  Smalls:=TImageList.CreateSize(16,16);
  SysIL := SHGetFileInfo('', 0, SFI, SizeOf(SFI), SHGFI_SYSICONINDEX or SHGFI_SMALLICON);
  if SysIL <> 0 then begin
    Smalls.Handle := SysIL;
    Smalls.ShareImages := True;
    Smalls.drawingstyle:=dsTransparent;
  end;
  Larges:=TImageList.CreateSize(32,32);
  SysIL := SHGetFileInfo('', 0, SFI, SizeOf(SFI), SHGFI_SYSICONINDEX or SHGFI_LARGEICON);
  if SysIL <> 0 then begin
    Larges.Handle := SysIL;
    Larges.ShareImages := True;
    Larges.drawingstyle:=dsTransparent;
  end;
finalization
  Larges.Free;
  Smalls.Free;
end.
