unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,ExtCtrls,comctrls,DVDrives;

type
  TForm1 = class(TForm)
    DVDrivesCombo: TDVDrivesCombo;
    DVDrivesList: TDVDrivesList;
    GroupBox1: TGroupBox;
    AutoUpdate: TCheckBox;
    GroupBox2: TGroupBox;
    DisplaySysName: TCheckBox;
    DisplayIcons: TCheckBox;
    DisplayBrackets: TCheckBox;
    DisplayLabel: TCheckBox;
    Button1: TButton;
    IconsSize: TRadioGroup;
    TextCase: TRadioGroup;
    ViewDrivesType: TGroupBox;
    Unknown: TCheckBox;
    NonExisting: TCheckBox;
    Removable: TCheckBox;
    Remote: TCheckBox;
    cdrom: TCheckBox;
    ram: TCheckBox;
    Fixed: TCheckBox;
    Panel1: TPanel;
    procedure AutoUpdateClick(Sender: TObject);
    procedure DisplayIconsClick(Sender: TObject);
    procedure DisplayBracketsClick(Sender: TObject);
    procedure DisplayLabelClick(Sender: TObject);
    procedure DisplaySysNameClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure IconsSizeClick(Sender: TObject);
    procedure TextCaseClick(Sender: TObject);
    procedure UnknownClick(Sender: TObject);
    procedure DVDrivesComboChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.AutoUpdateClick(Sender: TObject);
begin
  DVDrivesCombo.AutoUpdate:=AutoUpdate.Checked;
end;

procedure TForm1.DisplayIconsClick(Sender: TObject);
var b:Boolean;
begin
  b:=DisplayIcons.Checked;
  DVDrivesCombo.DisplayIcons:=b;
  DVDrivesList.DisplayIcons:=b;
end;

procedure TForm1.DisplayBracketsClick(Sender: TObject);
var b:Boolean;
begin
  b:=DisplayBrackets.Checked;
  DVDrivesCombo.DisplayBrackets:=b;
  DVDrivesList.DisplayBrackets:=b;
end;

procedure TForm1.DisplayLabelClick(Sender: TObject);
var b:Boolean;
begin
  b:=DisplayLabel.Checked;
  DVDrivesCombo.DisplayLabel:=b;
  DVDrivesList.DisplayLabel:=b;
end;

procedure TForm1.DisplaySysNameClick(Sender: TObject);
var b:Boolean;
begin
  b:=DisplaySysName.Checked;
  DVDrivesCombo.DisplaySysName:=b;
  DVDrivesList.DisplaySysName:=b;
  DisplayBrackets.Enabled:=not b;
  DisplayLabel.Enabled:=not b;
  TextCase.Enabled:=not b;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  DVDrivesCombo.UpdateDrives;
  DVDrivesList.UpdateDrives;
end;

procedure TForm1.IconsSizeClick(Sender: TObject);
var Size:TIconSize;
begin
  if IconsSize.ItemIndex=0 then Size:=isSmall
  else
    Size:=isLarge;
  DVDrivesCombo.IconsSize:=Size;
  DVDrivesList.IconsSize:=Size;
end;

procedure TForm1.TextCaseClick(Sender: TObject);
var TxtCase:TTextCase;
begin
  if TextCase.ItemIndex=0 then TxtCase:=tcLowerCase
  else
    TxtCase:=tcUpperCase;
  DVDrivesCombo.TextCase:=TxtCase;
  DVDrivesList.TextCase:=TxtCase;
end;

procedure TForm1.UnknownClick(Sender: TObject);
var i:TDriveType;
begin
  if Sender=Unknown then i:=dtUnknown;
  if Sender=NonExisting then i:=dtNonExisting;
  if Sender=Removable then i:=dtRemovable;
  if Sender=Fixed then i:=dtFixed;
  if Sender=Remote then i:=dtRemote;
  if Sender=Cdrom then i:=dtCDROM;
  if Sender=Ram then i:=dtRamDisk;
  if (Sender as TCheckBox).Checked=True then
  begin
    DVDrivesCombo.ViewDrivesType:=DVDrivesCombo.ViewDrivesType+[i];
    DVDrivesList.ViewDrivesType:=DVDrivesList.ViewDrivesType+[i];
  end
  else
  begin
    DVDrivesCombo.ViewDrivesType:=DVDrivesCombo.ViewDrivesType-[i];
    DVDrivesList.ViewDrivesType:=DVDrivesList.ViewDrivesType-[i];
  end;
end;

procedure TForm1.DVDrivesComboChange(Sender: TObject);
begin
  Panel1.Caption:='Selected drives - Combo: '+dvdrivescombo.Drive+
                  ' , List: '+dvdriveslist.drive;
end;

end.
